#include "libparse.h"

using namespace lib_parse;

CheckException::CheckException(const QString& msg) : msg_store(msg) {}

QString CheckException::message() const { return msg_store; }

Analyzer::Analyzer(const QList<std::shared_ptr<const CheckProvider> >& providers) : check_providers(providers) {}

std::shared_ptr<const ast_gen::ElementAccess> Analyzer::validCheckWith(std::shared_ptr<const ast_gen::ElementAccess> root) const {
    for (auto& v : check_providers)
        v->validCheck(root);

    return root;
}
