#pragma once

#include <memory>
#include <QList>
#include <libtoken.h>
#include "libsyntax.h"

namespace ast_basic {
    // ﷨ ================================================================================================

    /**
     * @brief ﷨ڵ/Ҷڵ/ʷڵ
     */
    class TokenNode {
    public:
        /**
         * @brief ȡļ·
         * @return
         */
        virtual QString filePath() const = 0;

        /**
         * @brief ǷҶӽڵ
         * @return
         */
        virtual bool isLeaf() const = 0;
        /**
         * @brief ȡڵ㶨Token
         * @return
         */
        virtual QList<std::shared_ptr<const lib_token::Token>> tokens() const = 0;
        /**
         * @brief ýڵӽڵ
         * @param tokens
         * @return
         */
        virtual std::shared_ptr<const TokenNode> filledWith(const QList<std::shared_ptr<const TokenNode>>& child_nodes) const = 0;
    };

    /**
     * @brief ﷨Ͻڵ/ʽڵ
     */
    class ExprNode : public TokenNode {
    public:

        /**
         * @brief ʽ
         * @return
         */
        virtual std::shared_ptr<const lib_syntax::ExprRule> defined() const = 0;
        /**
         * @brief ֱӱʽ
         * @return
         */
        virtual QList<std::shared_ptr<const ExprNode>> exprNodes() const = 0;

        /**
         * @brief ȡTokenNodeֱԪؼ
         * @param index ʼԪ 0ʼ
         * @param length 
         * @return
         */
        virtual QList<std::shared_ptr<const TokenNode>> childTokensMid(int index, int length = 1) const = 0;
    };


    // ﷨ ==========================================================================================

    /**
     * @brief ʷڵ
     */
    class LIBSYNTAX_EXPORT TokenNodeImpl : public ast_basic::TokenNode {
    private:
        std::shared_ptr<const lib_token::Token> word_store;

    public:
        TokenNodeImpl(std::shared_ptr<const lib_token::Token> word);

        // TokenNode interface
    public:
        virtual QString filePath() const override;
        virtual bool isLeaf() const override;
        virtual QList<std::shared_ptr<const lib_token::Token>> tokens() const override;
        virtual std::shared_ptr<const TokenNode> filledWith(const QList<std::shared_ptr<const TokenNode> >& tokens) const override;
    };

    /**
     * @brief ʽڵ
     */
    class LIBSYNTAX_EXPORT ExprNodeImpl : public ast_basic::ExprNode {
    private:
        std::shared_ptr<const lib_syntax::ExprRule> _expr_rule;
        QList<std::shared_ptr<const TokenNode>> children_store;

    public:
        ExprNodeImpl(std::shared_ptr<const lib_syntax::ExprRule> bind);

        // TokenNode interface
    public:
        virtual QString filePath() const override;
        virtual bool isLeaf() const override;
        virtual QList<std::shared_ptr<const lib_token::Token>> tokens() const override;
        virtual std::shared_ptr<const TokenNode> filledWith(const QList<std::shared_ptr<const TokenNode> >& child_nodes) const override;

        // ExprNode interface
    public:
        virtual std::shared_ptr<const lib_syntax::ExprRule> defined() const override;
        virtual QList<std::shared_ptr<const ExprNode>> exprNodes() const override;
        virtual QList<std::shared_ptr<const TokenNode> > childTokensMid(int index, int length) const override;
    };
}